<?php

namespace ModulesGarden\WithoutDNS\CPanel\Controllers;

use ModulesGarden\WithoutDNS\CPanel\Helpers\Lang;

require_once __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Lang.php";

abstract class BaseController
{
    protected string $templateName;
    protected string $templatesDirectory = __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "templates" . DIRECTORY_SEPARATOR;

    abstract protected function getVariables() :array;

    public function renderTemplate() :void
    {
        $lang = new Lang();

        $variables = $this->getVariables();
        $templateName = $this->templateName;

        $cpanel = $GLOBALS['cpanel'];

        ob_start();
        include $this->templatesDirectory . $this->templateName . ".php";
        $content = ob_get_clean();

        include $this->templatesDirectory . "base.php";
    }

    protected function getUsername()
    {
        $cpanel = $GLOBALS['cpanel'];
        $username = $cpanel->cpanelprint('$user');

        return $username;
    }
}