<?php

namespace ModulesGarden\WithoutDNS\CPanel\Controllers;

require_once __DIR__ . DIRECTORY_SEPARATOR . "BaseController.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Domains.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "JSON.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Configuration.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "DomainsUrls.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "API" . DIRECTORY_SEPARATOR . "WithoutDNS.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Log.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'base' . DIRECTORY_SEPARATOR . 'frontend' . DIRECTORY_SEPARATOR . "jupiter" . DIRECTORY_SEPARATOR . "WithoutDNS" . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Lang.php";

use ModulesGarden\WithoutDNS\CPanel\Helpers\Lang;
use ModulesGarden\WithoutDNS\Share\API\WithoutDNS;
use ModulesGarden\WithoutDNS\Share\Helpers\Configuration;
use ModulesGarden\WithoutDNS\Share\Helpers\Domains;
use ModulesGarden\WithoutDNS\Share\Helpers\DomainsUrls;
use ModulesGarden\WithoutDNS\Share\Helpers\JSON;
use ModulesGarden\WithoutDNS\Share\Helpers\Log;

class DomainsController extends BaseController
{
    protected $lang;
    public function __construct()
    {
        $this->lang = new Lang();
        $this->templateName = "domains";
    }

    protected function getVariables(): array
    {
        return [
        ];
    }

    public function getDomainsAjax()
    {
        try
        {
            $userDomains = Domains::getDomains();
            $domainsURLs = DomainsUrls::getAllRecords();
            $domains = [];

            foreach($userDomains as $domain)
            {
                $domainURLData = DomainsUrls::findRecordInAllRecords($domainsURLs,'domain_name',$domain['url']);
                if ($domainURLData &&
                    key_exists('valid_until', $domainURLData['data']) &&
                    (
                        $domainURLData['data']['valid_until'] === "0000-00-00 00:00:00" ||
                        strtotime($domainURLData['data']['valid_until']) > strtotime(date('Y-m-d H:i:s'))
                    ))
                {
                    if (isset($domainURLData['data']['type']) && $domainURLData['data']['type'] === DomainsUrls::MAIN) {
                        $visitNow = '
                            <div class="container-fluid p-0">
                                <div class="row align-items-center gx-1 d-flex"> 
                                    <div class="col-auto"> 
                                        <a href="https://' . $domainURLData['data']['path'] . '" class="text-decoration-none fw-bold text-primary" target="_blank">
                                            https://' . $domainURLData['data']['path'] . '
                                        </a>
                                        <a href="https://' . $domainURLData['data']['path'] . '" class="btn btn-outline-primary btn-sm" target="_blank">
                                            <i class="bi bi-box-arrow-up-right me-2"></i> '.$this->lang->get("visit_now").'
                                        </a>
                                    </div>
                                    <div class="col-auto ms-auto">
                                        <button class="btn btn-outline-danger btn-sm deleteTemporaryUrlButton" data-domain="' . htmlspecialchars($domain['url']) . '" data-bs-toggle="modal" data-bs-target="#deleteTemporaryUrlModal">
                                            <i class="bi bi-trash me-2"></i> '.$this->lang->get("delete").'
                                        </button>
                                    </div>
                                </div>
                            </div>';
                    }else{
                        $visitNow = '
                            <div class="container-fluid p-0">
                                <div class="row align-items-center gx-1 d-flex"> 
                                    <div class="col-auto"> 
                                        <a href="https://' . $domainURLData['data']['path'] . '" class="text-decoration-none fw-bold text-primary" target="_blank">
                                            https://' . $domainURLData['data']['path'] . '
                                        </a>
                                        <a href="https://' . $domainURLData['data']['path'] . '" class="btn btn-outline-primary btn-sm" target="_blank">
                                            <i class="bi bi-box-arrow-up-right me-2"></i> '.$this->lang->get("visit_now").'
                                        </a>
                                    </div>
                                </div>
                            </div>';
                    }

                    $domains[] = [
                        $domain['url'],
                        $visitNow
                    ];
                }else{
                    // Add a "Generate URL" button for the second column
                    $generateUrlButton = '<button class="btn btn-primary generate-url" data-domain="' . htmlspecialchars($domain['url']) . '" data-ip="' . htmlspecialchars($domain['ip_address']) . '" data-bs-toggle="modal" data-bs-target="#generateTemporaryUrl">
                                        <i class="bi bi-link me-2"></i> '.$this->lang->get("generate_url").'
                                    </button>';
                    $domains[] = [
                        $domain['url'],
                        $generateUrlButton
                    ];
                }

            }
        }
        catch(\Exception $e)
        {
            Log::log($e->getMessage());

            return JSON::jsonEncode([
                'error' => $e->getMessage()
            ],true);
        }

        return json_encode([
            'draw' => $_GET['draw'],
            'recordsTotal' => count($domains),
            'recordsFiltered' => count($domains),
            'data' => $domains
        ], true);
    }

    public function generateTemporaryUrlAjax()
    {
        try {
            $apiKey = Configuration::getByName(Configuration::API_TOKEN);

            $data['target_domain'] = $_REQUEST['domain'];

            if(key_exists('ip',$_REQUEST))
            {
                $data['target_ip'] = $_REQUEST['ip'];
            }

            if ($apiKey)
            {
                $api = new WithoutDNS(WithoutDNS::API_URL,$apiKey);

                if ($this->testConnection($api))
                {
                    $data['source_domain'] = Configuration::getByName(Configuration::TEMP_DOMAIN);
                    $data['valid_until'] = $this->getDate(Configuration::getByName(Configuration::TEMP_URL_DURATION));
                    $result = $api->createSite($data);
                    $result['data']['type'] = DomainsUrls::MAIN;
                }else{
                    $result = $api->createTrial($data);
                    $result['data']['type'] = DomainsUrls::TRIAL;
                }
            }else{
                $api = new WithoutDNS(WithoutDNS::API_URL,'');

                $result = $api->createTrial($data);
                $result['data']['type'] = DomainsUrls::TRIAL;
            }

            if (key_exists('status', $result) && $result['status'] === 'success')
            {
                DomainsUrls::updateOrCreate($data['target_domain'], serialize(json_encode($result['data'])));

                Log::log($this->lang->get('temporary_url_has_been_successfully_generated_for_domain').$data['target_domain'],'Generating Temporary URL',$result);

                return JSON::jsonEncode([
                    'message' => $this->lang->get('temporary_url_has_been_successfully_generated')
                ]);
            }else{
                Log::log($this->lang->get('unable_to_generate_temporary_url_for_domain').$data['target_domain'],'Generating Temporary URL',$result);

                return JSON::jsonEncode([
                    'error' => key_exists('message', $result) ? $result['message'] : (key_exists('error', $result) ? $result['error'] : $this->lang->get('unable_to_generate_temporary_url'))
                ],true);
            }
        }catch(\Exception $e)
        {
            Log::log($e->getMessage(),'Generating Temporary URL',[
                'domain' => $_REQUEST['domain']
            ]);

            return JSON::jsonEncode([
                'error' => $e->getMessage()
            ],true);
        }
    }

    public function deleteTemporaryUrlAjax()
    {
        $domain = $_REQUEST['domain'];
        try {
            $domainUrlData = DomainsUrls::getByDomainName($domain);
            if ($domainUrlData) {
                DomainsUrls::deleteByDomainName($domain);

                $api = new WithoutDNS(
                    WithoutDNS::API_URL,
                    Configuration::getByName(Configuration::API_TOKEN, '')
                );

                if ($this->testConnection($api))
                {
                    if (isset($domainUrlData['data']['model']['id'])) {
                        $api->deleteSite($domainUrlData['data']['model']['id']);
                    }
                }

                Log::log($this->lang->get('temporary_url_has_been_successfully_deleted_for_domain').$domain, 'Delete Temporary URL', ['domain' => $domain]);

                return JSON::jsonEncode([
                    'message' => $this->lang->get('temporary_url_has_been_successfully_deleted')
                ]);
            }
        }catch(\Exception $e)
        {
            Log::log($e->getMessage(),'Delete Temporary URL',[
                'domain' => $domain
            ]);

            return JSON::jsonEncode([
                'error' => $e->getMessage()
            ],true);
        }
    }

    public function getDate($key): string
    {
        $dateModifications = [
            '15m' => '+15 minutes',
            '1h'  => '+1 hour',
            '24h' => '+24 hours',
            '7d'  => '+7 days',
            '30d' => '+30 days',
            'never' => 'never',
        ];

        if ($key === 'never') {
            return 'Never';
        }

        $currentDate = new \DateTime();
        $currentDate->modify($dateModifications[$key] ?? '+15 minutes');

        return $currentDate->format('Y-m-d H:i:s');
    }

    public function testConnection(WithoutDNS $api): bool
    {
        try {
            //try to connect to API
            $result = $api->getServices();

            if (key_exists('status',$result) && $result['status'] === 'success') {
                return true;
            }
        } catch (\Exception $e) {
            Log::log($e->getMessage(),'Test Connection');
        }

        return false;
    }
}