<div class="table-responsive">
    <table id="domains" class="table table-striped table-bordered border-dark w-100">
        <thead class="table-dark">
        <tr>
            <th><?php echo $lang->get("domain"); ?></th>
            <th><?php echo $lang->get("temporary_url"); ?></th>
        </tr>
        </thead>
    </table>
</div>

<div class='modal' id='generateTemporaryUrl' tabindex='-1' role='dialog' aria-labelledby='generateUrlModalLabel' aria-hidden='true'>
    <div class='modal-dialog modal-dialog-centered'>
        <div class='modal-content' style='border-radius: 15px;'>
            <div class='modal-header' style='border-bottom: none;'>
                <h5 class='modal-title' id='generateUrlModalLabel'>
                    <svg width='24' height='24' viewBox='0 0 24 24' fill='none' xmlns='http://www.w3.org/2000/svg'>
                        <g clip-path='url(#clip0_11484_428696)'>
                            <path d='M23 14V4.38462C23 2.51534 21.4847 1 19.6154 1H4.38462C2.51534 1 1 2.51534 1 4.38462V19.6154C1 21.4847 2.51534 23 4.38462 23H8' stroke='black' stroke-width='2' stroke-linecap='round' stroke-linejoin='round'></path>
                            <circle cx='14.5' cy='15.5' r='4.5' stroke='#e87a2c' stroke-width='2'></circle>
                            <path d='M1 7H23.5' stroke='black' stroke-width='2'></path>
                            <circle cx='5' cy='4' r='1' fill='black'></circle>
                            <circle cx='9' cy='4' r='1' fill='black'></circle>
                            <circle cx='13' cy='4' r='1' fill='black'></circle>
                            <path d='M18.5 18.5L22.5 22.5' stroke='#e87a2c' stroke-width='2' stroke-linecap='round'></path>
                        </g>
                        <defs>
                            <clipPath id='clip0_11484_428696'>
                                <rect width='24' height='24' fill='white'></rect>
                            </clipPath>
                        </defs>
                    </svg>
                    <?php echo $lang->get("preview_site"); ?>
                </h5>
                <button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button>
            </div>
            <div class='modal-body' style='border-top: none;'>
                <input id="domainName" type="hidden" value="">
                <input id="ipAddress" type="hidden" value="">
                <p style='font-size: 16px; line-height: 24px; font-weight: 300;'><?php echo $lang->get("your_site_can_be_preview_on_temporary_url"); ?></p>
            </div>
            <div class='modal-footer d-flex justify-content-center' style='border-top: none; margin-top: 0px;'>
                <button id="generateTemporaryUrlButton" class='btn btn-success' style='width: 400px'>
                    <?php echo $lang->get("get_temporary_url"); ?>
                </button>
            </div>
        </div>
    </div>
</div>

<div class="modal" id="deleteTemporaryUrlModal" tabindex="-1" role="dialog" aria-labelledby="deleteTemporaryUrlModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="deleteTemporaryUrlModalLabel"><?php echo $lang->get("delete_temporary_url"); ?></h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <div class="alert alert-danger mb-0 bootstrap-alert" role="alert">
                    <?php echo $lang->get("are_you_sure_you_want_to_delete_this_temporary_url"); ?>
                </div>
                <form>
                    <input type="hidden" id="domainForDelete">
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary mb-1" data-bs-dismiss="modal"><?php echo $lang->get("close"); ?></button>
                <button id="deleteTemporaryUrl" type="button" class="btn btn-danger mb-1"><?php echo $lang->get("delete"); ?></button>
            </div>
        </div>
    </div>
</div>


<script>
    let domains;

    $(document).ready(function () {
        domains = new DataTable("#domains", {
            ajax: {
                url: "./index.live.php",
                data: function (d) {
                    d.ajax = true;
                    d.controller = 'domains';
                    d.action = 'getDomainsAjax';

                    return d;
                }
            },
            ordering: false,
            searching: false,
            responsive: true,
            autoWidth: false,
            lengthChange: false,
            language: {
                "decimal":        "",
                "emptyTable":     "<?php echo $lang->get("no_data_available"); ?>",
                "info":           "<?php echo $lang->get("showing_start_to_end_entries"); ?>",
                "infoEmpty":      "<?php echo $lang->get("showing_zero_to_zero_entries"); ?>",
                "infoFiltered":   "<?php echo $lang->get("filtered_from_max_entries"); ?>",
                "infoPostFix":    "",
                "thousands":      ",",
                "lengthMenu":     "<?php echo $lang->get("show_menu_entries"); ?>",
                "loadingRecords": "<?php echo $lang->get("loading"); ?>",
                "processing":     "",
                "search":         "<?php echo $lang->get("search"); ?>",
                "zeroRecords":    "<?php echo $lang->get("no_matching_records"); ?>",
                "paginate": {
                    "first":      "<?php echo $lang->get("first"); ?>",
                    "last":       "<?php echo $lang->get("last"); ?>",
                    "next":       "<?php echo $lang->get("next"); ?>",
                    "previous":   "<?php echo $lang->get("previous"); ?>"
                },
                "aria": {
                    "orderable":  "<?php echo $lang->get("order_by_this_column"); ?>",
                    "orderableReverse": "<?php echo $lang->get("reverse_order_this_column"); ?>"
                }
            },
            columnDefs: [
                {
                    targets: 1, // Target the second column
                    render: function (data, type, row) {
                        return data; // Render the button HTML as-is
                    }
                }
            ]
        });

        $(document).on('click', '.generate-url', function () {
            var domain = $(this).data('domain');
            var ip = $(this).data('ip');

            $('#domainName').val(domain);
            $('#ipAddress').val(ip);
        });

        $('#generateTemporaryUrl').on('hidden.bs.modal', function (event) {
            $('#domainName').val('');
            $('#ipAddress').val('');
        });

        $('#generateTemporaryUrlButton').on('click', function(e) {
            // Show loader
            $(this).prop('disabled', true); // Disable the button to prevent multiple clicks
            $(this).html(`
                    <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                    Generating...
                `);

            // Perform AJAX request
            $.ajax({
                url: 'index.live.php?controller=domains&action=generateTemporaryUrlAjax&ajax=true',
                method: 'POST',
                dataType: 'json',
                data: {
                    domain: $('#domainName').val(),
                    ip: $('#ipAddress').val(),
                },
                success: function(data) {
                    // Reload DataTable
                    domains.ajax.reload();

                    let message = data.data.message;

                    let div = $('#messages');
                    div.append('<div class="alert bootstrap-alert alert-success alert-dismissible show" role="alert">\n' + message  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');

                    // Hide the modal
                    bootstrap.Modal.getInstance(document.getElementById('generateTemporaryUrl')).hide();
                },
                error: function(data) {
                    let error = data.responseJSON.data.error;

                    let div = $('#messages');
                    div.append('<div class="alert bootstrap-alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');

                    bootstrap.Modal.getInstance(document.getElementById('generateTemporaryUrl')).hide();
                },
                complete: function() {
                    // Hide loader and reset button text
                    $('#generateTemporaryUrlButton').prop('disabled', false); // Re-enable the button
                    $('#generateTemporaryUrlButton').html('Generate Temporary URL');
                }
            });
        });

        $(document).on('click', '.deleteTemporaryUrlButton', function () {
            var domain = $(this).data('domain');

            $('#domainForDelete').val(domain);
        });

        $('#deleteTemporaryUrlModal').on('hidden.bs.modal', function (event) {
            $('#domainForDelete').val('');
        });

        $('#deleteTemporaryUrl').on('click', function(e) {
            // Show loader
            $(this).prop('disabled', true); // Disable the button to prevent multiple clicks
            $(this).html(`
                    <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                    Deleting...
                `);

            // Perform AJAX request
            $.ajax({
                url: 'index.live.php?controller=domains&action=deleteTemporaryUrlAjax&ajax=true',
                method: 'POST',
                dataType: 'json',
                data: {
                    domain: $('#domainForDelete').val(),
                },
                success: function(data) {
                    // Reload DataTable
                    domains.ajax.reload();

                    let message = data.data.message;

                    let div = $('#messages');
                    div.append('<div class="alert bootstrap-alert alert-success alert-dismissible show" role="alert">\n' + message  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');

                    // Hide the modal
                    bootstrap.Modal.getInstance(document.getElementById('deleteTemporaryUrlModal')).hide();
                },
                error: function(data) {
                    let error = data.responseJSON.data.error;

                    let div = $('#messages');
                    div.append('<div class="alert bootstrap-alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');

                    bootstrap.Modal.getInstance(document.getElementById('deleteTemporaryUrlModal')).hide();
                },
                complete: function() {
                    // Hide loader and reset button text
                    $('#deleteTemporaryUrl').prop('disabled', false); // Re-enable the button
                    $('#deleteTemporaryUrl').html('Delete');
                }
            });
        });
    });
</script>

