<?php

namespace ModulesGarden\WithoutDNS\Share\API;

class WHM
{
    protected $hostname = "http://127.0.0.1:2086/json-api/";

    protected $token;

    public function __construct()
    {
        $this->token = file_get_contents('/usr/local/cpanel/Cpanel/WithoutDNS/.sm_tokenapi');

        if(!$this->token)
        {
            $this->token = trim(shell_exec("/usr/local/cpanel/3rdparty/bin/perl /usr/local/cpanel/share/WithoutDNS/Wrapper/wrapper.pl getAccessHash"));
        }
    }

    public function request($action)
    {
        $curl = curl_init();

        curl_setopt($curl, CURLOPT_HTTPHEADER, [
            "Authorization: WHM root:" . $this->token
        ]);

        curl_setopt($curl, CURLOPT_URL, $this->hostname . "/" . $action);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);


        $data = curl_exec($curl);

        return json_decode($data, 1);
    }

    public function getPackages()
    {
        $result = $this->request('listpkgs');

        return $result['package'];
    }

    public function getUserDomains($username)
    {
        $domains = [];
        // Make the API request
        $result = $this->request('cpanel?cpanel_jsonapi_user='.$username.'&cpanel_jsonapi_apiversion=3&cpanel_jsonapi_module=DomainInfo&cpanel_jsonapi_func=domains_data');

        if (isset($result['result']['data']['addon_domains']))
        {
            foreach ($result['result']['data']['addon_domains'] as $domain)
            {
                $domains[] =  $domain['domain'];
            }
        }

        if (isset($result['result']['data']['parked_domains']))
        {
            foreach ($result['result']['data']['parked_domains'] as $domain)
            {
                $domains[] =  $domain;
            }
        }

        if (isset($result['result']['data']['main_domain']))
        {
            $domains[] =  $result['result']['data']['main_domain']['domain'];
        }

        return $domains;
    }

    public function getAccount($username)
    {
        $result = $this->request("accountsummary?user=$username");

        return $result;
    }

    public function getTweakSetting($key,$default='')
    {
        $result = $this->request("get_tweaksetting?api.version=1&key=$key");

        if (isset($result['data']))
        {
            if (isset($result['data']['tweaksetting']))
            {
                return $result['data']['tweaksetting']['value'];
            }
        }

        return $default;
    }
}