<?php

namespace ModulesGarden\WithoutDNS\Share\Config;

class Config
{
    protected $configFile = "/usr/local/cpanel/etc/WithoutDNS.ini";

    protected $databaseHost;
    protected $databaseName;
    protected $databaseUsername;
    protected $databasePassword;

    public function __construct()
    {
        $configuration = parse_ini_file($this->configFile);

        if(!$configuration)
        {
            $configuration = parse_ini_string(shell_exec("/usr/local/cpanel/3rdparty/bin/perl /usr/local/cpanel/share/WithoutDNS/Wrapper/wrapper.pl getConfiguration"));
        }

        $this->databaseHost = $configuration['DB_HOST'];
        $this->databaseName = $configuration['DB_NAME'];
        $this->databaseUsername = $configuration['DB_USERNAME'];
        $this->databasePassword = $configuration['DB_PASSWORD'];
    }

    public function getDatabaseHost()
    {
        return $this->databaseHost;
    }

    public function getDatabaseName()
    {
        return $this->databaseName;
    }

    public function getDatabaseUsername()
    {
        return $this->databaseUsername;
    }

    public function getDatabasePassword()
    {
        return $this->databasePassword;
    }
}