<?php

namespace ModulesGarden\WithoutDNS\Share\Helpers;

use ModulesGarden\WithoutDNS\Share\Config\Config;
use PDO;

require_once __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "Config" . DIRECTORY_SEPARATOR . "Config.php";

class Database
{
    protected $connection;
    public function __construct()
    {
        $config = new Config();

        $this->connection = new PDO("mysql:host=" . $config->getDatabaseHost(). ";dbname=" . $config->getDatabaseName(), $config->getDatabaseUsername(), $config->getDatabasePassword());
        $this->connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    }

    public function getConnection()
    {
        return $this->connection;
    }

    public function select($query, $data = [])
    {
        $stmt = $this->connection->prepare($query);

        foreach($data as $key => $value)
        {
            $stmt->bindParam($key, $value);
        }

        $stmt->execute();

        $result = $stmt->fetchAll(PDO::FETCH_NUM);

        return $result;
    }

    public function insert($query, $data)
    {
        $stmt = $this->connection->prepare($query);

        foreach($data as $key => $value)
        {
            $stmt->bindValue($key, $value);
        }

        $stmt->execute();
    }
}