<?php

namespace ModulesGarden\WithoutDNS\WHM\Helpers;

require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "API" . DIRECTORY_SEPARATOR . "WHM.php";

use ModulesGarden\WithoutDNS\Share\API\WHM;

class Lang
{
    protected $langs;

    public function __construct()
    {
        $whmAPI = new WHM();
        $lang = $whmAPI->getTweakSetting('server_locale','en');

        $langsDirectory = __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "langs" . DIRECTORY_SEPARATOR;

        if(file_exists($langsDirectory . DIRECTORY_SEPARATOR . $lang . ".php"))
        {
            $this->langs = include($langsDirectory . DIRECTORY_SEPARATOR . $lang . ".php");
        }
        else
        {
            if(file_exists($langsDirectory . DIRECTORY_SEPARATOR . "en" . ".php"))
            {
                $this->langs = include($langsDirectory . DIRECTORY_SEPARATOR . "en" . ".php");
            }
            else
            {
                $this->langs = [];
            }
        }
    }

    public function get($lang)
    {
        return $this->langs[$lang] ?? $lang . " [no lang]";
    }
}