let apiConfiguration;

window.onload = function () {
    var reloading = sessionStorage.getItem("reloading");
    if (reloading) {
        let message = sessionStorage.getItem("messagesToShow");
        let error = sessionStorage.getItem("error");

        let div = $('#messages');
        if (error === '0')
        {
            div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message +
                '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                '       </div>');
        }else
        {
            div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + message  +
                '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                '       </div>');
        }
        sessionStorage.removeItem("reloading");
        sessionStorage.removeItem("messagesToShow")
        sessionStorage.removeItem("error")
    }
};

function reloadPageWithMessage() {
    sessionStorage.setItem("reloading", "true");
    document.location.reload();
}

$(document).ready(function () {
    $('#testConnection').on('click', function () {
        let form = $('#apiConfigurationForm');
        console.log(getFormData(form));

        $.ajax({
            url: 'index.php?controller=apiConfiguration&action=testConnectionAjax&ajax=true',
            method: 'POST',
            dataType: 'json',
            data: {
                formData: getFormData(form)
            },
            success: function(data) {
                let message = data.data.message;

                sessionStorage.setItem("messagesToShow", message)
                sessionStorage.setItem("error", '0')
                reloadPageWithMessage();
            },
            error: function(data) {
                let error = data.responseJSON.data.error;

                let div = $('#messages');
                div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            }
        });
    });

    $('#saveChanges').on('click', function () {
        let form = $('#apiConfigurationForm');

        $.ajax({
            url: 'index.php?controller=apiConfiguration&action=saveChangesAjax&ajax=true',
            method: 'POST',
            dataType: 'json',
            data: {
                formData: getFormData(form)
            },
            success: function(data) {
                sessionStorage.setItem("messagesToShow", data.data.message)
                sessionStorage.setItem("error", '0')
                reloadPageWithMessage();
            },
            error: function(data) {
                let error = data.responseJSON.data.error;

                let div = $('#messages');
                div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            }
        });
    });
});


function getFormData(form){
    var o = {};
    var a = form.serializeArray();
    $.each(a, function() {
        if (o[this.name]) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });
    return o;
}