let logs;

$(document).ready(function () {
    logs = new DataTable("#logs", {
        ajax: {
            url: "./index.php",
            data: function (d) {
                d.ajax = true;
                d.controller = 'logs';
                d.action = 'getLogsAjax';

                return d;
            }
        },
        lengthChange: false,
        order: [[1, 'desc']],
        columnDefs: [
            {
                "targets": 5,
                "render": function (data, type, row) {
                    return "<button type='button' data-server='" + row[0] + "' class='btn btn-primary' data-bs-toggle='modal' data-bs-target='#deleteLogModal'>Delete</button>"
                }
            }
        ],
    });

    $('#deleteLogModal').on('show.bs.modal', function (event) {
        let button = $(event.relatedTarget);

        let logId = button.data('server');

        $('#deleteLogModalId').val(logId);
    });

    $('#deleteLogModalButton').on('click', function () {
        let logId = $('#deleteLogModalId').val();

        $.ajax({
            url: 'index.php?controller=logs&action=deleteLogAjax&ajax=true',
            method: 'POST',
            dataType: 'json',
            data: {
                logId: logId
            },
            success: function(data) {
                logs.ajax.reload();
                bootstrap.Modal.getInstance(document.getElementById('deleteLogModal')).hide();
                let message = data.data.message;
                let div = $('#messages');

                div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            },
            error: function(data) {
                let error = data.responseJSON.data.error;

                let div = $('#messages');
                div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            }
        });
    });

    $('#saveConfigurationButton').on('click', function () {
        let days = $('#daysInput').val();

        $.ajax({
            url: 'index.php?controller=logs&action=configureCleanupAjax&ajax=true',
            method: 'POST',
            dataType: 'json',
            data: {
                days: days
            },
            success: function(data) {
                logs.ajax.reload();
                bootstrap.Modal.getInstance(document.getElementById('configureModal')).hide();
                let message = data.data.message;
                let div = $('#messages');

                div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            },
            error: function(data) {
                let error = data.responseJSON.data.error;

                let div = $('#messages');
                div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            }
        });
    });

    $('#deleteLogsButton').on('click', function () {
        let days = $('#daysInput2').val();

        $.ajax({
            url: 'index.php?controller=logs&action=deleteLogsAjax&ajax=true',
            method: 'POST',
            dataType: 'json',
            data: {
                days: days
            },
            success: function(data) {
                logs.ajax.reload();
                bootstrap.Modal.getInstance(document.getElementById('deleteLogsModal')).hide();
                let message = data.data.message;
                let div = $('#messages');

                div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            },
            error: function(data) {
                let error = data.responseJSON.data.error;

                let div = $('#messages');
                div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                    '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                    '       </div>');
            }
        });
    });
});