<?php

namespace ModulesGarden\WithoutDNS\WHM\Controllers;

require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'whostmgr' . DIRECTORY_SEPARATOR . 'docroot' . DIRECTORY_SEPARATOR . "cgi" . DIRECTORY_SEPARATOR . "WithoutDNS" . DIRECTORY_SEPARATOR ."Helpers" . DIRECTORY_SEPARATOR ."Lang.php";

use ModulesGarden\WithoutDNS\WHM\Helpers\Lang;

abstract class BaseController
{
    protected string $templateName;
    protected string $templatesDirectory = __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "templates" . DIRECTORY_SEPARATOR;

    abstract protected function getVariables() :array;

    public function renderTemplate() :void
    {
        $lang = new Lang();

        $variables = $this->getVariables();
        $templateName = $this->templateName;

        ob_start();
        include $this->templatesDirectory . $this->templateName . ".php";
        $content = ob_get_clean();

        include $this->templatesDirectory . "base.php";
    }
}