<?php

namespace ModulesGarden\WithoutDNS\WHM\Controllers;

require_once __DIR__ . DIRECTORY_SEPARATOR . "BaseController.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Log.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "JSON.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Configuration.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'whostmgr' . DIRECTORY_SEPARATOR . 'docroot' . DIRECTORY_SEPARATOR . "cgi" . DIRECTORY_SEPARATOR . "WithoutDNS" . DIRECTORY_SEPARATOR ."Helpers" . DIRECTORY_SEPARATOR ."Lang.php";

use ModulesGarden\WithoutDNS\Share\Helpers\Log;
use ModulesGarden\WithoutDNS\Share\Helpers\JSON;
use ModulesGarden\WithoutDNS\Share\Helpers\Configuration;
use ModulesGarden\WithoutDNS\WHM\Helpers\Lang;

class LogsController extends BaseController
{
    protected $lang;
    public function __construct()
    {
        $this->lang = new Lang();

        $this->templateName = "logs";
    }

    protected function getVariables() :array
    {
        return [
            'configuration' => Configuration::getAll()
        ];
    }

    public function getLogsAjax()
    {
        try
        {
            $result = Log::getLogs();

            $logs = [];

            foreach($result as $log)
            {
                $logs[] = [
                    $log['id'],
                    $log['date'],
                    $log['message'],
                    $log['action'],
                    $log['data']
                ];
            }
        }
        catch (\Exception $e)
        {
            Log::log($e->getMessage());

            return JSON::jsonEncode([
                'error' => $e->getMessage()
            ],true);
        }

        return json_encode([
            'draw' => $_GET['draw'],
            'recordsTotal' => count($logs),
            'recordsFiltered' => count($logs),
            'data' => $logs
        ], true);
    }

    public function deleteLogAjax()
    {
        $logId = $_POST['logId'];

        try
        {
            Log::deleteLog($logId);
        }
        catch(\Exception $e)
        {
            Log::log($e->getMessage());

            return JSON::jsonEncode([
               'error' => $e->getMessage()
            ]);
        }

        return JSON::jsonEncode([
            'message' => $this->lang->get('log_has_been_deleted_successfully')
        ]);
    }

    public function configureCleanupAjax()
    {
        $days = $_POST['days'];

        try
        {
            Configuration::updateOrCreate(Configuration::NUMBER_OF_DAYS_FOR_LOG_DELETE,$days);
            Log::log($this->lang->get('remove_logs_older_than_days_changed').$days,'Cleanup Configuration Saved');
        }
        catch(\Exception $e)
        {
            Log::log($e->getMessage());

            return JSON::jsonEncode([
                'error' => $e->getMessage()
            ]);
        }

        return JSON::jsonEncode([
            'message' => $this->lang->get('configuration_saved_successfully')
        ]);
    }

    public function deleteLogsAjax()
    {
        $days = $_POST['days'];

        try
        {
            $logsDeleted = Log::deleteLogsOlderThanDays($days);
        }
        catch(\Exception $e)
        {
            Log::log($e->getMessage());

            return JSON::jsonEncode([
                'error' => $e->getMessage()
            ]);
        }

        return JSON::jsonEncode([
            'message' => sprintf($this->lang->get('deleted_logs_older_than_days'),$logsDeleted,$days)
        ]);
    }
}