<?php

require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Log.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "DomainsUrls.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "API" . DIRECTORY_SEPARATOR . "WithoutDNS.php";
require_once DIRECTORY_SEPARATOR . 'usr' . DIRECTORY_SEPARATOR . 'local' . DIRECTORY_SEPARATOR . 'cpanel' . DIRECTORY_SEPARATOR . 'share' . DIRECTORY_SEPARATOR . 'WithoutDNS' . DIRECTORY_SEPARATOR . "Helpers" . DIRECTORY_SEPARATOR . "Configuration.php";

use ModulesGarden\WithoutDNS\Share\Helpers\Configuration;
use ModulesGarden\WithoutDNS\Share\Helpers\Log;
use ModulesGarden\WithoutDNS\Share\Helpers\DomainsUrls;
use ModulesGarden\WithoutDNS\Share\API\WithoutDNS;

$numberOfDaysForLogs = Configuration::getByName(Configuration::NUMBER_OF_DAYS_FOR_LOG_DELETE,30);

$logsDeleted = Log::deleteLogsOlderThanDays($numberOfDaysForLogs);

Log::log('Cron cleanup successful. Number of logs deleted: '.$logsDeleted,'Automatic cleanup of logs');

$domainUrls = DomainsUrls::deleteExpiredRecords();

Log::log('Cron cleanup of outdated temporary urls successful. Number of temporary urls deleted: '.$domainUrls,'Automatic cleanup of temporary urls');

deleteNotExistentInWithoutDNSTemporaryURLs();

function getSites()
{
    $sites = [];
    try {
        $api = new WithoutDNS(WithoutDNS::API_URL,Configuration::getByName(Configuration::API_TOKEN,''));
        $result = $api->getSites();

        if ($result['status'] == 'success' && isset($result['data']['records'])) {
            foreach ($result['data']['records'] as $site) {
                $sites[$site['id']] = $site;
            }
        }

        return $sites;
    }catch(Exception $e){
        return $sites;
    }
}

function deleteNotExistentInWithoutDNSTemporaryURLs()
{
    $domainUrlsRecords = DomainsUrls::getAllRecords();
    $mainTemporaryUrls = getSites();
    if(!empty($domainUrlsRecords)){
        foreach($domainUrlsRecords as $record){
            if (isset($record['data']))
            {
                if (isset($record['data']['type']))
                {
                    if ($record['data']['type'] === DomainsUrls::MAIN)
                    {
                        if (isset($record['data']['model']['id']))
                        {
                            if (!isset($mainTemporaryUrls[$record['data']['model']['id']]))
                            {
                                DomainsUrls::deleteByDomainName($record['domain_name']);

                                Log::log('Temporary URL for domain: '.$record['domain_name'].' has been deleted by cron','Deleting not existing in WithoutDNS temporary urls');
                            }
                        }
                    }
                }
            }
        }
    }
}
