<script src="./assets/apiConfiguration.js"></script>

<div id="messages"></div>

<div class="card border-primary mb-4">
    <div class="card-header bg-primary text-white">
        <h5 class="card-title mb-0"><?php echo $lang->get("how_to_configure_withoutdns"); ?></h5>
    </div>
    <div class="card-body">
        <p class="card-text"><?php echo $lang->get("to_fully_configure"); ?></p>
        <ol class="mb-4">
            <li><?php echo $lang->get("go_to"); ?> <a href="https://withoutdns.com/api-configuration" target="_blank">https://withoutdns.com/api-configuration</a></li>
            <li><?php echo $lang->get("login_to_your_account_if_needed"); ?></li>
            <li><?php echo $lang->get("create_a_new_api_token"); ?></li>
            <li><?php echo $lang->get("copy_and_paste_the_api_token"); ?></li>
            <li><?php echo $lang->get("perform_test_connection"); ?></li>
            <li><?php echo $lang->get("after_performing_test_connection"); ?></li>
        </ol>
        <p class="card-text"><strong><?php echo $lang->get("note"); ?></strong> <?php echo $lang->get("without_fully_completing_the_configuration"); ?></p>
    </div>
</div>

<form id="apiConfigurationForm">
    <!-- API Token Field -->
    <div class="mb-3">
        <label for="apiToken" class="form-label"><?php echo $lang->get("api_token"); ?></label>
        <input type="text" class="form-control" name="apiToken" id="apiToken" placeholder="<?php echo $lang->get("enter_api_token"); ?>"
               value="<?php echo isset($variables['configuration']['apiToken']) ? htmlspecialchars($variables['configuration']['apiToken']) : ''; ?>">
    </div>

    <!-- Temporary URL Duration Field -->
    <?php if (!empty($variables['durationOptions'])): ?>
        <div class="mb-3">
            <label for="tempUrlDuration" class="form-label"><?php echo $lang->get("temporary_url_duration"); ?></label>
            <select class="form-select" name="tempUrlDuration" id="tempUrlDuration">
                <?php foreach ($variables['durationOptions'] as $value => $label): ?>
                    <option value="<?php echo htmlspecialchars($value); ?>"
                        <?php if (isset($variables['configuration']['tempUrlDuration']) && $variables['configuration']['tempUrlDuration'] == $value): ?>
                            selected
                        <?php endif; ?>
                    >
                        <?php echo htmlspecialchars($label); ?>
                    </option>
                <?php endforeach; ?>
            </select>
        </div>
    <?php endif; ?>

    <!-- Temporary Domain Field -->
    <?php if (!empty($variables['sourceDomains'])): ?>
        <div class="mb-3">
            <label for="tempDomain" class="form-label"><?php echo $lang->get("temporary_domain"); ?></label>
            <select class="form-select" name="tempDomain" id="tempDomain">
                <?php foreach ($variables['sourceDomains'] as $value => $label): ?>
                    <option value="<?php echo htmlspecialchars($value); ?>"
                        <?php if (isset($variables['configuration']['tempDomain']) && $variables['configuration']['tempDomain'] == $value): ?>
                            selected
                        <?php endif; ?>
                    >
                        <?php echo htmlspecialchars($label); ?>
                    </option>
                <?php endforeach; ?>
            </select>
        </div>
    <?php endif; ?>

    <!-- Buttons -->
    <div class="d-flex justify-content-between">
        <!-- Test Connection Button -->
        <button id="testConnection" type="button" class="btn btn-outline-secondary">
            <i class="bi bi-arrow-repeat me-1"></i> <?php echo $lang->get("test_connection"); ?>
        </button>

        <!-- Save Changes Button -->
        <button id="saveChanges" type="button" class="btn btn-success">
            <?php echo $lang->get("save_changes"); ?>
        </button>
    </div>
</form>