<div id="messages"></div>

<!-- Global Actions Toolbar -->
<div class="d-flex justify-content-between mb-3">
    <div>
        <button id="deleteSelected" class="btn btn-danger btn-sm me-2" data-bs-toggle="modal" data-bs-target="#deleteLogsModal">
            <i class="fas fa-trash"></i> <?php echo $lang->get("delete_logs_button"); ?>
        </button>
        <button id="refreshTable" class="btn btn-secondary btn-sm" data-bs-toggle="modal" data-bs-target="#configureModal">
            <i class="fas fa-cog"></i> <?php echo $lang->get("configure_cleanup_button"); ?>
        </button>
    </div>
</div>

<table id="logs" class="display" style="width: 100%">
    <thead>
    <tr>
        <th><?php echo $lang->get("id"); ?></th>
        <th><?php echo $lang->get("date"); ?></th>
        <th><?php echo $lang->get("message"); ?></th>
        <th><?php echo $lang->get("action"); ?></th>
        <th><?php echo $lang->get("data"); ?></th>
        <th><?php echo $lang->get("actions"); ?></th>
    </tr>
    </thead>
</table>

<div class="modal" id="deleteLogModal" tabindex="-1" role="dialog" aria-labelledby="deleteLogModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="deleteLogModalLabel"><?php echo $lang->get("delete_server"); ?></h5>
                <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <p><?php echo $lang->get("are_you_sure_you_want_to_delete_this_log"); ?></p>
                <form>
                    <input type="hidden" id="deleteLogModalId">
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?php echo $lang->get("close"); ?></button>
                <button id="deleteLogModalButton" type="button" class="btn btn-danger"><?php echo $lang->get("delete_log"); ?></button>
            </div>
        </div>
    </div>
</div>

<div class="modal" id="configureModal" tabindex="-1" aria-labelledby="configureModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <!-- Modal Header -->
            <div class="modal-header">
                <h5 class="modal-title" id="configureModalLabel"><?php echo $lang->get("configure_log_removal"); ?></h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>

            <!-- Modal Body -->
            <div class="modal-body">
                <form>
                    <div class="mb-3">
                        <label for="daysInput" class="form-label"><?php echo $lang->get("remove_logs_older_than_days"); ?></label>
                        <input type="number" class="form-control" id="daysInput" min="1" value="<?php echo $variables['configuration']['daysToDelete'] ?? 30; ?>" required>
                    </div>
                </form>
            </div>

            <!-- Modal Footer -->
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?php echo $lang->get("close"); ?></button>
                <button type="button" class="btn btn-primary" id="saveConfigurationButton"><?php echo $lang->get("save_changes"); ?></button>
            </div>
        </div>
    </div>
</div>

<div class="modal" id="deleteLogsModal" tabindex="-1" aria-labelledby="deleteLogsModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <!-- Modal Header -->
            <div class="modal-header">
                <h5 class="modal-title" id="deleteLogsModalLabel"><?php echo $lang->get("delete_logs"); ?></h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>

            <!-- Modal Body -->
            <div class="modal-body">
                <p><?php echo $lang->get("are_you_sure_you_want_to_delete_logs"); ?></p>
                <div class="mb-3">
                    <label for="daysInput2" class="form-label"><?php echo $lang->get("delete_logs_older_than_days"); ?></label>
                    <input type="number" class="form-control" id="daysInput2" min="1" value="30" required>
                </div>
            </div>

            <!-- Modal Footer -->
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?php echo $lang->get("cancel"); ?></button>
                <button type="button" class="btn btn-danger" id="deleteLogsButton"><?php echo $lang->get("delete"); ?></button>
            </div>
        </div>
    </div>
</div>

<script>
    let logs;

    $(document).ready(function () {
        logs = new DataTable("#logs", {
            ajax: {
                url: "./index.php",
                data: function (d) {
                    d.ajax = true;
                    d.controller = 'logs';
                    d.action = 'getLogsAjax';

                    return d;
                }
            },
            lengthChange: false,
            order: [[1, 'desc']],
            language: {
                "decimal":        "",
                "emptyTable":     "<?php echo $lang->get("no_data_available"); ?>",
                "info":           "<?php echo $lang->get("showing_start_to_end_entries"); ?>",
                "infoEmpty":      "<?php echo $lang->get("showing_zero_to_zero_entries"); ?>",
                "infoFiltered":   "<?php echo $lang->get("filtered_from_max_entries"); ?>",
                "infoPostFix":    "",
                "thousands":      ",",
                "lengthMenu":     "<?php echo $lang->get("show_menu_entries"); ?>",
                "loadingRecords": "<?php echo $lang->get("loading"); ?>",
                "processing":     "",
                "search":         "<?php echo $lang->get("search"); ?>",
                "zeroRecords":    "<?php echo $lang->get("no_matching_records"); ?>",
                "paginate": {
                    "first":      "<?php echo $lang->get("first"); ?>",
                    "last":       "<?php echo $lang->get("last"); ?>",
                    "next":       "<?php echo $lang->get("next"); ?>",
                    "previous":   "<?php echo $lang->get("previous"); ?>"
                },
                "aria": {
                    "orderable":  "<?php echo $lang->get("order_by_this_column"); ?>",
                    "orderableReverse": "<?php echo $lang->get("reverse_order_this_column"); ?>"
                }
            },
            columnDefs: [
                {
                    "targets": 5,
                    "render": function (data, type, row) {
                        return "<button type='button' data-server='" + row[0] + "' class='btn btn-primary' data-bs-toggle='modal' data-bs-target='#deleteLogModal'>Delete</button>"
                    }
                }
            ],
        });

        $('#deleteLogModal').on('show.bs.modal', function (event) {
            let button = $(event.relatedTarget);

            let logId = button.data('server');

            $('#deleteLogModalId').val(logId);
        });

        $('#deleteLogModalButton').on('click', function () {
            let logId = $('#deleteLogModalId').val();

            $.ajax({
                url: 'index.php?controller=logs&action=deleteLogAjax&ajax=true',
                method: 'POST',
                dataType: 'json',
                data: {
                    logId: logId
                },
                success: function(data) {
                    logs.ajax.reload();
                    bootstrap.Modal.getInstance(document.getElementById('deleteLogModal')).hide();
                    let message = data.data.message;
                    let div = $('#messages');

                    div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');
                },
                error: function(data) {
                    let error = data.responseJSON.data.error;

                    let div = $('#messages');
                    div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');
                }
            });
        });

        $('#saveConfigurationButton').on('click', function () {
            let days = $('#daysInput').val();

            $.ajax({
                url: 'index.php?controller=logs&action=configureCleanupAjax&ajax=true',
                method: 'POST',
                dataType: 'json',
                data: {
                    days: days
                },
                success: function(data) {
                    logs.ajax.reload();
                    bootstrap.Modal.getInstance(document.getElementById('configureModal')).hide();
                    let message = data.data.message;
                    let div = $('#messages');

                    div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');
                },
                error: function(data) {
                    let error = data.responseJSON.data.error;

                    let div = $('#messages');
                    div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');
                }
            });
        });

        $('#deleteLogsButton').on('click', function () {
            let days = $('#daysInput2').val();

            $.ajax({
                url: 'index.php?controller=logs&action=deleteLogsAjax&ajax=true',
                method: 'POST',
                dataType: 'json',
                data: {
                    days: days
                },
                success: function(data) {
                    logs.ajax.reload();
                    bootstrap.Modal.getInstance(document.getElementById('deleteLogsModal')).hide();
                    let message = data.data.message;
                    let div = $('#messages');

                    div.append('<div class="alert alert-success alert-dismissible show" role="alert">\n' + message  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');
                },
                error: function(data) {
                    let error = data.responseJSON.data.error;

                    let div = $('#messages');
                    div.append('<div class="alert alert-danger alert-dismissible show" role="alert">\n' + error  +
                        '        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>\n' +
                        '       </div>');
                }
            });
        });
    });
</script>